<?php

namespace App\Http\Controllers\User;

use App\Http\Controllers\Controller;
use App\Models\Agenda;
use App\Models\Kategori;
use App\Models\UserAgenda;
use Exception;
use Illuminate\Console\View\Components\Alert;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Validator;

class AgendaController extends Controller
{
    public function index(Request $request)
    {
       
        // $ngajar = DB::connection('siakad')->table('akt_ajar_dosen as a')
        //     ->select('k.id_kls','m.nm_mk', 'j.int_hari1', 'j.int_hari2', 'j.jam11', 'j.jam12')
        //     ->leftJoin('kelas_kuliah as k', 'k.id_kls', '=', 'a.id_kls')
        //     ->leftJoin('kelas_jadwal as j', 'j.id_kls', '=', 'a.id_kls')
        //     ->leftJoin('matkul as m', 'm.id_mk', '=', 'k.id_mk')
        //     ->leftJoin('reg_ptk as r', 'r.id_reg_ptk', '=', 'a.id_reg_ptk')

        //     ->leftJoin('sdm as s', 's.id_sdm', '=', 'r.id_sdm')
        //     ->where('s.nip', $nip)
        //     ->get();

        //     dd($ngajar);
        if($request->ajax()) {

            $tahun = '2023';
            $nip = '199309052019032017';

            // $data = UserAgenda::whereDate('start', '>=', $request->start)
            //         ->whereDate('end', '<=', $request->end)
            //            ->get(['id', 'title', 'start', 'end']);

            $data = DB::connection('eoffice')->table('tr_surat_masuk')
            ->select('tr_surat_masuk.id', 'tr_surat_masuk.perihal as title', 'tr_surat_masuk.tglmulai as start', 'tr_surat_masuk.tglmulai as end', 'tr_surat_masuk.jam_mulai', 'tr_surat_masuk.jam_selesai')
            ->leftJoin('tr_penerima_surat_masuk as a', 'a.idsurat', '=', 'tr_surat_masuk.id')
            // ->where('a.nip', $nip)
            ->where('tr_surat_masuk.perihal', 'like', '%undangan%')
            ->where('tr_surat_masuk.tglmulai', '>=', $request->start)
            ->where('tr_surat_masuk.tglmulai', '<=', $request->end)
            // ->where('tr_surat_masuk.tahun', $tahun)
            ->get(['id', 'title', 'start', 'end']);

            $getData = array();
            foreach ($data as $item) {
                
            }

            // $data['surat_keluar_eoffice'] = DB::connection('eoffice')->table('tr_surat_keluar')
            // ->select('tr_surat_keluar.perihal', 'tr_surat_keluar.tglmulai', 'tr_surat_keluar.jam_mulai', 'tr_surat_keluar.jam_selesai')
            // ->leftJoin('tr_penerima_surat_keluar as a', 'a.idsurat', '=', 'tr_surat_keluar.id')
            // ->where('a.nip', $nip)
            // ->where('tr_surat_keluar.perihal', 'like', '%undangan%')
            // ->where('tr_surat_keluar.tahun', $tahun)
            // ->get();
            // dd($surat);
            return response()->json($data);
        }
        // $data = UserAgenda::all();
        // return $data;
        return view('user.index');
    }

    public function surat_masuk(Request $request)
    {
        $nip = '199309052019032017';
        $tahun = '2023';

        // $data = UserAgenda::whereDate('start', '>=', $request->start)
        //                ->whereDate('end', '<=', $request->end)
        //                ->get(['id', 'title', 'start', 'end']);

        $surat = DB::connection('eoffice')->table('tr_surat_masuk')
        ->select('tr_surat_masuk.id', 'tr_surat_masuk.perihal as title', 'tr_surat_masuk.tglmulai as start', 'tr_surat_masuk.tglmulai as end', 'tr_surat_masuk.jam_mulai', 'tr_surat_masuk.jam_selesai')
        ->leftJoin('tr_penerima_surat_masuk as a', 'a.idsurat', '=', 'tr_surat_masuk.id')
        // ->where('a.nip', $nip)
        ->where('tr_surat_masuk.perihal', 'like', '%undangan%')
        // ->where('tr_surat_masuk.tahun', $tahun)
        ->get(['id', 'title', 'start', 'end']);
        // dd($surat);
    }

    public function create()
    {
        $kategori = Kategori::query()->get();
        return view('user.create')->with('data', $kategori);
    }

    public function store(Request $request)
    {
        // dd($request);
        $data = [];

        DB::beginTransaction();

        // Validator::make($request->all(), [
        //     'nama' => 'required|string',
        //     'tanggal' => 'required',
        //     'waktu' => 'required',
        //     'lokasi' => 'string',
        //     'link_zoom' => 'required|string',
        //     'id_zoom' => 'required|string',
        //     'passcode_zoom' => 'required|string',
        // ]);

        try {
            // $swalData = [
            //     'type' => 'success',
            //     'title' => 'Agenda'
            // ];
            $data = $request->except(['_method','_token']);
            $data['id'] =
            $data['idunit'] = '1526d530-d992-49ba-b663-3ed703b96a0f'; //nanti bakal diambil dari session user
            $data['statusacara'] = 0;

            Agenda::query()->create($data);

            DB::commit();

            return back()->with('notify-swal', );

            alert()->flash('Data berhasil ditambahkan', 'success');
        } catch(Exception $e) {
            dd($e);
            Log::debug('Tambah Agenda Error');
            Log::error($e);

            DB::rollBack();
        }
    }
}
